@echo off
rem ---
rem --- online install batch file for Meadow & NTEmacs
rem ---

rem --- Argument
rem ---   elc : Byte compile only
rem ---   all, install or NOARG : install
rem ---   clean : cleanup
rem ---


rem --- check if executed from make.bat
if not "%SUBMAKEOK%"=="OK" goto prnusage
set SUBMAKEOK=

set PRODBBC=%EMACS% -batch -q -no-site-file -l makeconf.el
set PRODDST=%LISPDIR%\online

rem --- check command
set arg1=%1
if "%arg1%"=="" goto install
if "%arg1%"=="all" goto install
if "%arg1%"=="install" goto install
if "%arg1%"=="elc" goto compile
if "%arg1%"=="clean" goto clean
echo Unrecognized argument: specify either 'elc', 'all', 'install', 'clean'
echo Default is 'install' (when no argument is specified.)
goto end

rem --- install
:install

rem --- Check destination directory
if "%LISPDIR%"=="" goto errexit1
if not exist %PRODDST% mkdir %PRODDST%
copy make1.bat %PRODDST% >nul
if not exist %PRODDST%\make1.bat mkdir %PRODDST%
copy make1.bat %PRODDST% >nul
if not exist %PRODDST%\make1.bat goto errexit2
del %PRODDST%\make1.bat

echo Compiling files...
echo online.el
%PRODBBC% -f batch-byte-compile online.el

echo Copying files to %PRODDST%...
if exist %PRODDST%\online.el del %PRODDST%\online.el
xcopy /k/r online.el %PRODDST%
if exist %PRODDST%\online.elc del %PRODDST%\online.elc
if exist online.elc xcopy /k/r online.elc %PRODDST%

del online.elc

echo Done. Please set load-path to include %PRODDST% if necessary.
goto end

rem --- compile
:compile
echo Compiling files...
echo online.el
%PRODBBC% -f batch-byte-compile online.el
goto end

rem --- |
:clean
echo Deleting *.elc
del *.elc
echo Deleting *~
del *~
echo Done.
goto end

:errexit1
echo Error: variable LISPDIR is not specified.
goto pauseend

:errexit2
echo Error: cannot access install directory %PRODDST%
goto pauseend

:printenv
echo EMACS=%EMACS%
echo LISPDIR=%LISPDIR%
goto pauseend

:prnusage
echo This file should not be executed by itself. Use makeit.bat.

:pauseend
echo Type any key when you're done reading the error message.
pause

rem --- end of makeit.bat
:end
set PRODBBC=
set PRODDST=
